
# (C) 2001-2013 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 12.1 177 win32 2013.01.31.13:09:42

# ----------------------------------------
# Auto-generated simulation script

# ----------------------------------------
# Initialize the variable
if ![info exists SYSTEM_INSTANCE_NAME] { 
  set SYSTEM_INSTANCE_NAME ""
} elseif { ![ string match "" $SYSTEM_INSTANCE_NAME ] } { 
  set SYSTEM_INSTANCE_NAME "/$SYSTEM_INSTANCE_NAME"
} 

if ![info exists TOP_LEVEL_NAME] { 
  set TOP_LEVEL_NAME "altera_eth_10g_mac_base_kr"
} elseif { ![ string match "" $TOP_LEVEL_NAME ] } { 
  set TOP_LEVEL_NAME "$TOP_LEVEL_NAME"
} 

if ![info exists QSYS_SIMDIR] { 
  set QSYS_SIMDIR "./../"
} elseif { ![ string match "" $QSYS_SIMDIR ] } { 
  set QSYS_SIMDIR "$QSYS_SIMDIR"
} 

set Aldec "Riviera"
if { [ string match "*Active-HDL*" [ vsim -version ] ] } {
  set Aldec "Active"
}

if { [ string match "Active" $Aldec ] } {
  scripterconf -tcl
  createdesign "$TOP_LEVEL_NAME"  "."
  opendesign "$TOP_LEVEL_NAME"
}

# ----------------------------------------
# Copy ROM/RAM files to simulation directory

# ----------------------------------------
# Create compilation libraries
proc ensure_lib { lib } { if ![file isdirectory $lib] { vlib $lib } }
ensure_lib      ./libraries     
ensure_lib      ./libraries/work
vmap       work ./libraries/work
ensure_lib                       ./libraries/altera_ver           
vmap       altera_ver            ./libraries/altera_ver           
ensure_lib                       ./libraries/lpm_ver              
vmap       lpm_ver               ./libraries/lpm_ver              
ensure_lib                       ./libraries/sgate_ver            
vmap       sgate_ver             ./libraries/sgate_ver            
ensure_lib                       ./libraries/altera_mf_ver        
vmap       altera_mf_ver         ./libraries/altera_mf_ver        
ensure_lib                       ./libraries/altera_lnsim_ver     
vmap       altera_lnsim_ver      ./libraries/altera_lnsim_ver     
ensure_lib                       ./libraries/stratixv_ver         
vmap       stratixv_ver          ./libraries/stratixv_ver         
ensure_lib                       ./libraries/stratixv_hssi_ver    
vmap       stratixv_hssi_ver     ./libraries/stratixv_hssi_ver    
ensure_lib                       ./libraries/stratixv_pcie_hip_ver
vmap       stratixv_pcie_hip_ver ./libraries/stratixv_pcie_hip_ver
ensure_lib                                                                                                 ./libraries/rsp_xbar_mux                                                                                   
vmap       rsp_xbar_mux                                                                                    ./libraries/rsp_xbar_mux                                                                                   
ensure_lib                                                                                                 ./libraries/rsp_xbar_demux                                                                                 
vmap       rsp_xbar_demux                                                                                  ./libraries/rsp_xbar_demux                                                                                 
ensure_lib                                                                                                 ./libraries/cmd_xbar_demux                                                                                 
vmap       cmd_xbar_demux                                                                                  ./libraries/cmd_xbar_demux                                                                                 
ensure_lib                                                                                                 ./libraries/id_router                                                                                      
vmap       id_router                                                                                       ./libraries/id_router                                                                                      
ensure_lib                                                                                                 ./libraries/addr_router                                                                                    
vmap       addr_router                                                                                     ./libraries/addr_router                                                                                    
ensure_lib                                                                                                 ./libraries/lc_lb_timing_adapter                                                                           
vmap       lc_lb_timing_adapter                                                                            ./libraries/lc_lb_timing_adapter                                                                           
ensure_lib                                                                                                 ./libraries/line_splitter_timing_adapter                                                                   
vmap       line_splitter_timing_adapter                                                                    ./libraries/line_splitter_timing_adapter                                                                   
ensure_lib                                                                                                 ./libraries/line_lb_timing_adapter                                                                         
vmap       line_lb_timing_adapter                                                                          ./libraries/line_lb_timing_adapter                                                                         
ensure_lib                                                                                                 ./libraries/line_loopback                                                                                  
vmap       line_loopback                                                                                   ./libraries/line_loopback                                                                                  
ensure_lib                                                                                                 ./libraries/lc_splitter_timing_adapter                                                                     
vmap       lc_splitter_timing_adapter                                                                      ./libraries/lc_splitter_timing_adapter                                                                     
ensure_lib                                                                                                 ./libraries/rsp_xbar_mux_002                                                                               
vmap       rsp_xbar_mux_002                                                                                ./libraries/rsp_xbar_mux_002                                                                               
ensure_lib                                                                                                 ./libraries/rsp_xbar_demux_010                                                                             
vmap       rsp_xbar_demux_010                                                                              ./libraries/rsp_xbar_demux_010                                                                             
ensure_lib                                                                                                 ./libraries/cmd_xbar_demux_002                                                                             
vmap       cmd_xbar_demux_002                                                                              ./libraries/cmd_xbar_demux_002                                                                             
ensure_lib                                                                                                 ./libraries/rsp_xbar_mux_001                                                                               
vmap       rsp_xbar_mux_001                                                                                ./libraries/rsp_xbar_mux_001                                                                               
ensure_lib                                                                                                 ./libraries/rsp_xbar_demux_002                                                                             
vmap       rsp_xbar_demux_002                                                                              ./libraries/rsp_xbar_demux_002                                                                             
ensure_lib                                                                                                 ./libraries/cmd_xbar_demux_001                                                                             
vmap       cmd_xbar_demux_001                                                                              ./libraries/cmd_xbar_demux_001                                                                             
ensure_lib                                                                                                 ./libraries/id_router_010                                                                                  
vmap       id_router_010                                                                                   ./libraries/id_router_010                                                                                  
ensure_lib                                                                                                 ./libraries/addr_router_002                                                                                
vmap       addr_router_002                                                                                 ./libraries/addr_router_002                                                                                
ensure_lib                                                                                                 ./libraries/id_router_002                                                                                  
vmap       id_router_002                                                                                   ./libraries/id_router_002                                                                                  
ensure_lib                                                                                                 ./libraries/addr_router_001                                                                                
vmap       addr_router_001                                                                                 ./libraries/addr_router_001                                                                                
ensure_lib                                                                                                 ./libraries/rxtx_timing_adapter_pauselen_tx                                                                
vmap       rxtx_timing_adapter_pauselen_tx                                                                 ./libraries/rxtx_timing_adapter_pauselen_tx                                                                
ensure_lib                                                                                                 ./libraries/rxtx_timing_adapter_pauselen_rx                                                                
vmap       rxtx_timing_adapter_pauselen_rx                                                                 ./libraries/rxtx_timing_adapter_pauselen_rx                                                                
ensure_lib                                                                                                 ./libraries/txrx_timing_adapter_link_fault_status_export                                                   
vmap       txrx_timing_adapter_link_fault_status_export                                                    ./libraries/txrx_timing_adapter_link_fault_status_export                                                   
ensure_lib                                                                                                 ./libraries/txrx_timing_adapter_link_fault_status_rx                                                       
vmap       txrx_timing_adapter_link_fault_status_rx                                                        ./libraries/txrx_timing_adapter_link_fault_status_rx                                                       
ensure_lib                                                                                                 ./libraries/rx_st_mux_rs_layer_2_avst                                                                      
vmap       rx_st_mux_rs_layer_2_avst                                                                       ./libraries/rx_st_mux_rs_layer_2_avst                                                                      
ensure_lib                                                                                                 ./libraries/rx_eth_gmii_decoder                                                                            
vmap       rx_eth_gmii_decoder                                                                             ./libraries/rx_eth_gmii_decoder                                                                            
ensure_lib                                                                                                 ./libraries/rx_st_error_adapter_stat                                                                       
vmap       rx_st_error_adapter_stat                                                                        ./libraries/rx_st_error_adapter_stat                                                                       
ensure_lib                                                                                                 ./libraries/rx_st_status_output_delay                                                                      
vmap       rx_st_status_output_delay                                                                       ./libraries/rx_st_status_output_delay                                                                      
ensure_lib                                                                                                 ./libraries/rx_eth_packet_overflow_control                                                                 
vmap       rx_eth_packet_overflow_control                                                                  ./libraries/rx_eth_packet_overflow_control                                                                 
ensure_lib                                                                                                 ./libraries/rx_eth_crc_pad_rem                                                                             
vmap       rx_eth_crc_pad_rem                                                                              ./libraries/rx_eth_crc_pad_rem                                                                             
ensure_lib                                                                                                 ./libraries/rx_eth_frame_status_merger                                                                     
vmap       rx_eth_frame_status_merger                                                                      ./libraries/rx_eth_frame_status_merger                                                                     
ensure_lib                                                                                                 ./libraries/rx_timing_adapter_frame_status_out_frame_decoder                                               
vmap       rx_timing_adapter_frame_status_out_frame_decoder                                                ./libraries/rx_timing_adapter_frame_status_out_frame_decoder                                               
ensure_lib                                                                                                 ./libraries/rx_st_timing_adapter_frame_status_in                                                           
vmap       rx_st_timing_adapter_frame_status_in                                                            ./libraries/rx_st_timing_adapter_frame_status_in                                                           
ensure_lib                                                                                                 ./libraries/rx_eth_lane_decoder                                                                            
vmap       rx_eth_lane_decoder                                                                             ./libraries/rx_eth_lane_decoder                                                                            
ensure_lib                                                                                                 ./libraries/rx_eth_link_fault_detection                                                                    
vmap       rx_eth_link_fault_detection                                                                     ./libraries/rx_eth_link_fault_detection                                                                    
ensure_lib                                                                                                 ./libraries/rx_st_timing_adapter_lane_decoder                                                              
vmap       rx_st_timing_adapter_lane_decoder                                                               ./libraries/rx_st_timing_adapter_lane_decoder                                                              
ensure_lib                                                                                                 ./libraries/rx_st_timing_adapter_interface_conversion                                                      
vmap       rx_st_timing_adapter_interface_conversion                                                       ./libraries/rx_st_timing_adapter_interface_conversion                                                      
ensure_lib                                                                                                 ./libraries/rx_register_map                                                                                
vmap       rx_register_map                                                                                 ./libraries/rx_register_map                                                                                
ensure_lib                                                                                                 ./libraries/tx_eth_link_fault_generation                                                                   
vmap       tx_eth_link_fault_generation                                                                    ./libraries/tx_eth_link_fault_generation                                                                   
ensure_lib                                                                                                 ./libraries/tx_eth_xgmii_termination                                                                       
vmap       tx_eth_xgmii_termination                                                                        ./libraries/tx_eth_xgmii_termination                                                                       
ensure_lib                                                                                                 ./libraries/tx_eth_packet_formatter                                                                        
vmap       tx_eth_packet_formatter                                                                         ./libraries/tx_eth_packet_formatter                                                                        
ensure_lib                                                                                                 ./libraries/tx_eth_gmii_encoder                                                                            
vmap       tx_eth_gmii_encoder                                                                             ./libraries/tx_eth_gmii_encoder                                                                            
ensure_lib                                                                                                 ./libraries/tx_eth_statistics_collector                                                                    
vmap       tx_eth_statistics_collector                                                                     ./libraries/tx_eth_statistics_collector                                                                    
ensure_lib                                                                                                 ./libraries/tx_st_timing_adapter_splitter_status_output                                                    
vmap       tx_st_timing_adapter_splitter_status_output                                                     ./libraries/tx_st_timing_adapter_splitter_status_output                                                    
ensure_lib                                                                                                 ./libraries/tx_st_timing_adapter_splitter_status_in                                                        
vmap       tx_st_timing_adapter_splitter_status_in                                                         ./libraries/tx_st_timing_adapter_splitter_status_in                                                        
ensure_lib                                                                                                 ./libraries/tx_st_error_adapter_stat                                                                       
vmap       tx_st_error_adapter_stat                                                                        ./libraries/tx_st_error_adapter_stat                                                                       
ensure_lib                                                                                                 ./libraries/tx_eth_frame_decoder                                                                           
vmap       tx_eth_frame_decoder                                                                            ./libraries/tx_eth_frame_decoder                                                                           
ensure_lib                                                                                                 ./libraries/tx_st_timing_adapter_frame_decoder                                                             
vmap       tx_st_timing_adapter_frame_decoder                                                              ./libraries/tx_st_timing_adapter_frame_decoder                                                             
ensure_lib                                                                                                 ./libraries/tx_st_splitter_1                                                                               
vmap       tx_st_splitter_1                                                                                ./libraries/tx_st_splitter_1                                                                               
ensure_lib                                                                                                 ./libraries/tx_st_pipeline_stage_rs                                                                        
vmap       tx_st_pipeline_stage_rs                                                                         ./libraries/tx_st_pipeline_stage_rs                                                                        
ensure_lib                                                                                                 ./libraries/tx_eth_crc_inserter                                                                            
vmap       tx_eth_crc_inserter                                                                             ./libraries/tx_eth_crc_inserter                                                                            
ensure_lib                                                                                                 ./libraries/tx_eth_address_inserter                                                                        
vmap       tx_eth_address_inserter                                                                         ./libraries/tx_eth_address_inserter                                                                        
ensure_lib                                                                                                 ./libraries/tx_st_mux_flow_control_user_frame                                                              
vmap       tx_st_mux_flow_control_user_frame                                                               ./libraries/tx_st_mux_flow_control_user_frame                                                              
ensure_lib                                                                                                 ./libraries/tx_st_pause_ctrl_error_adapter                                                                 
vmap       tx_st_pause_ctrl_error_adapter                                                                  ./libraries/tx_st_pause_ctrl_error_adapter                                                                 
ensure_lib                                                                                                 ./libraries/tx_eth_pause_ctrl_gen                                                                          
vmap       tx_eth_pause_ctrl_gen                                                                           ./libraries/tx_eth_pause_ctrl_gen                                                                          
ensure_lib                                                                                                 ./libraries/tx_eth_pause_beat_conversion                                                                   
vmap       tx_eth_pause_beat_conversion                                                                    ./libraries/tx_eth_pause_beat_conversion                                                                   
ensure_lib                                                                                                 ./libraries/tx_eth_pkt_backpressure_control                                                                
vmap       tx_eth_pkt_backpressure_control                                                                 ./libraries/tx_eth_pkt_backpressure_control                                                                
ensure_lib                                                                                                 ./libraries/tx_eth_pad_inserter                                                                            
vmap       tx_eth_pad_inserter                                                                             ./libraries/tx_eth_pad_inserter                                                                            
ensure_lib                                                                                                 ./libraries/tx_eth_packet_underflow_control                                                                
vmap       tx_eth_packet_underflow_control                                                                 ./libraries/tx_eth_packet_underflow_control                                                                
ensure_lib                                                                                                 ./libraries/tx_st_mux_avst_2_rs_layer                                                                      
vmap       tx_st_mux_avst_2_rs_layer                                                                       ./libraries/tx_st_mux_avst_2_rs_layer                                                                      
ensure_lib                                                                                                 ./libraries/tx_register_map                                                                                
vmap       tx_register_map                                                                                 ./libraries/tx_register_map                                                                                
ensure_lib                                                                                                 ./libraries/tx_bridge                                                                                      
vmap       tx_bridge                                                                                       ./libraries/tx_bridge                                                                                      
ensure_lib                                                                                                 ./libraries/crosser                                                                                        
vmap       crosser                                                                                         ./libraries/crosser                                                                                        
ensure_lib                                                                                                 ./libraries/eth_fifo_pause_ctrl_adapter                                                                    
vmap       eth_fifo_pause_ctrl_adapter                                                                     ./libraries/eth_fifo_pause_ctrl_adapter                                                                    
ensure_lib                                                                                                 ./libraries/pa_pg_after_timing_adapter                                                                     
vmap       pa_pg_after_timing_adapter                                                                      ./libraries/pa_pg_after_timing_adapter                                                                     
ensure_lib                                                                                                 ./libraries/pa_pg_before_timing_adapter                                                                    
vmap       pa_pg_before_timing_adapter                                                                     ./libraries/pa_pg_before_timing_adapter                                                                    
ensure_lib                                                                                                 ./libraries/dc_fifo_pause_adapt_pause_gen                                                                  
vmap       dc_fifo_pause_adapt_pause_gen                                                                   ./libraries/dc_fifo_pause_adapt_pause_gen                                                                  
ensure_lib                                                                                                 ./libraries/eth_loopback_composed                                                                          
vmap       eth_loopback_composed                                                                           ./libraries/eth_loopback_composed                                                                          
ensure_lib                                                                                                 ./libraries/eth_10g_mac                                                                                    
vmap       eth_10g_mac                                                                                     ./libraries/eth_10g_mac                                                                                    
ensure_lib                                                                                                 ./libraries/limiter                                                                                        
vmap       limiter                                                                                         ./libraries/limiter                                                                                        
ensure_lib                                                                                                 ./libraries/xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent_rsp_fifo                  
vmap       xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent_rsp_fifo                   ./libraries/xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent_rsp_fifo                  
ensure_lib                                                                                                 ./libraries/xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent                           
vmap       xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent                            ./libraries/xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent                           
ensure_lib                                                                                                 ./libraries/merlin_master_translator_0_avalon_universal_master_0_translator_avalon_universal_master_0_agent
vmap       merlin_master_translator_0_avalon_universal_master_0_translator_avalon_universal_master_0_agent ./libraries/merlin_master_translator_0_avalon_universal_master_0_translator_avalon_universal_master_0_agent
ensure_lib                                                                                                 ./libraries/xcvr_10gbase_kr_2_phy_mgmt_translator                                                          
vmap       xcvr_10gbase_kr_2_phy_mgmt_translator                                                           ./libraries/xcvr_10gbase_kr_2_phy_mgmt_translator                                                          
ensure_lib                                                                                                 ./libraries/reset_controller_mac_rx_2                                                                      
vmap       reset_controller_mac_rx_2                                                                       ./libraries/reset_controller_mac_rx_2                                                                      
ensure_lib                                                                                                 ./libraries/eth_10g_design_example_2                                                                       
vmap       eth_10g_design_example_2                                                                        ./libraries/eth_10g_design_example_2                                                                       
ensure_lib                                                                                                 ./libraries/xcvr_10gbase_kr_2                                                                              
vmap       xcvr_10gbase_kr_2                                                                               ./libraries/xcvr_10gbase_kr_2                                                                              
ensure_lib                                                                                                 ./libraries/xcvr_reset_control_2                                                                           
vmap       xcvr_reset_control_2                                                                            ./libraries/xcvr_reset_control_2                                                                           
ensure_lib                                                                                                 ./libraries/merlin_master_translator_0                                                                     
vmap       merlin_master_translator_0                                                                      ./libraries/merlin_master_translator_0                                                                     
ensure_lib                                                                                                 ./libraries/pll_0                                                                                          
vmap       pll_0                                                                                           ./libraries/pll_0                                                                                          

# ----------------------------------------
# Compile device library files
alias dev_com {
  echo "\[exec\] dev_com"
  vlog +define+SKIP_KEYWORDS_PRAGMA "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/altera_primitives.v"                    -work altera_ver           
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/220model.v"                             -work lpm_ver              
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/sgate.v"                                -work sgate_ver            
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/altera_mf.v"                            -work altera_mf_ver        
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/altera_lnsim.sv"                        -work altera_lnsim_ver     
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/aldec/stratixv_atoms_ncrypt.v"          -work stratixv_ver         
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/stratixv_atoms.v"                       -work stratixv_ver         
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/aldec/stratixv_hssi_atoms_ncrypt.v"     -work stratixv_hssi_ver    
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/stratixv_hssi_atoms.v"                  -work stratixv_hssi_ver    
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/aldec/stratixv_pcie_hip_atoms_ncrypt.v" -work stratixv_pcie_hip_ver
  vlog                              "//pg-swnas01a/swdev/acds_releases/acds/12.1/177/win64/quartus/eda/sim_lib/stratixv_pcie_hip_atoms.v"              -work stratixv_pcie_hip_ver
}

# ----------------------------------------
# Compile the design files in correct order
alias com {
  echo "\[exec\] com"
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv"                                                                                        -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_rsp_xbar_mux.sv"                          -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_rsp_xbar_demux.sv"                        -work rsp_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_cmd_xbar_demux.sv"                        -work cmd_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_id_router.sv"                             -work id_router                                                                                      
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_addr_router.sv"                           -work addr_router                                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_lc_lb_timing_adapter.v"                   -work lc_lb_timing_adapter                                                                           
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_line_splitter_timing_adapter.v"           -work line_splitter_timing_adapter                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_line_lb_timing_adapter.v"                 -work line_lb_timing_adapter                                                                         
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_loopback.v"                                                                                              -work line_loopback                                                                                  
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed_lc_splitter_timing_adapter.v"             -work lc_splitter_timing_adapter                                                                     
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv"                                                                                        -work rsp_xbar_mux_002                                                                               
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rsp_xbar_mux_002.sv"                                -work rsp_xbar_mux_002                                                                               
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rsp_xbar_demux_010.sv"                              -work rsp_xbar_demux_010                                                                             
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_cmd_xbar_demux_002.sv"                              -work cmd_xbar_demux_002                                                                             
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv"                                                                                        -work rsp_xbar_mux_001                                                                               
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rsp_xbar_mux_001.sv"                                -work rsp_xbar_mux_001                                                                               
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rsp_xbar_demux_002.sv"                              -work rsp_xbar_demux_002                                                                             
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_cmd_xbar_demux_001.sv"                              -work cmd_xbar_demux_001                                                                             
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv"                                                                                        -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rsp_xbar_mux.sv"                                    -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rsp_xbar_demux.sv"                                  -work rsp_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_cmd_xbar_demux.sv"                                  -work cmd_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_id_router_010.sv"                                   -work id_router_010                                                                                  
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_addr_router_002.sv"                                 -work addr_router_002                                                                                
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_id_router_002.sv"                                   -work id_router_002                                                                                  
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_addr_router_001.sv"                                 -work addr_router_001                                                                                
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_id_router.sv"                                       -work id_router                                                                                      
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_addr_router.sv"                                     -work addr_router                                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rxtx_timing_adapter_pauselen_tx.v"                  -work rxtx_timing_adapter_pauselen_tx                                                                
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rxtx_timing_adapter_pauselen_rx.v"                  -work rxtx_timing_adapter_pauselen_rx                                                                
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_txrx_timing_adapter_link_fault_status_export.v"     -work txrx_timing_adapter_link_fault_status_export                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_txrx_timing_adapter_link_fault_status_rx.v"         -work txrx_timing_adapter_link_fault_status_rx                                                       
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_rs_mux.v"                                                                                          -work rx_st_mux_rs_layer_2_avst                                                                      
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_gmii_decoder.v"                                                                                    -work rx_eth_gmii_decoder                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_gmii_decoder_dfa.v"                                                                                -work rx_eth_gmii_decoder                                                                            
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rx_st_error_adapter_stat.v"                         -work rx_st_error_adapter_stat                                                                       
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_delay.sv"                                                                                          -work rx_st_status_output_delay                                                                      
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_packet_overflow_control.v"                                                                         -work rx_eth_packet_overflow_control                                                                 
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_crc_pad_rem.v"                                                                                     -work rx_eth_crc_pad_rem                                                                             
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_crc_rem.v"                                                                                         -work rx_eth_crc_pad_rem                                                                             
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_packet_stripper.v"                                                                                     -work rx_eth_crc_pad_rem                                                                             
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_stage.sv"                                                                                 -work rx_eth_crc_pad_rem                                                                             
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_base.v"                                                                                   -work rx_eth_crc_pad_rem                                                                             
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_frame_status_merger.v"                                                                             -work rx_eth_frame_status_merger                                                                     
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rx_timing_adapter_frame_status_out_frame_decoder.v" -work rx_timing_adapter_frame_status_out_frame_decoder                                               
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rx_st_timing_adapter_frame_status_in.v"             -work rx_st_timing_adapter_frame_status_in                                                           
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_lane_decoder.v"                                                                                    -work rx_eth_lane_decoder                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_link_fault_detection.v"                                                                            -work rx_eth_link_fault_detection                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rx_st_timing_adapter_lane_decoder.v"                -work rx_st_timing_adapter_lane_decoder                                                              
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_rx_st_timing_adapter_interface_conversion.v"        -work rx_st_timing_adapter_interface_conversion                                                      
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_10g_rx_register_map.v"                                                                             -work rx_register_map                                                                                
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_clock_crosser.v"                                                                                   -work rx_register_map                                                                                
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_link_fault_generation.v"                                                                           -work tx_eth_link_fault_generation                                                                   
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_xgmii_termination.v"                                                                               -work tx_eth_xgmii_termination                                                                       
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_packet_formatter.v"                                                                                -work tx_eth_packet_formatter                                                                        
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_gmii_encoder.v"                                                                                    -work tx_eth_gmii_encoder                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_gmii_encoder_dfa.v"                                                                                -work tx_eth_gmii_encoder                                                                            
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_dc_fifo.v"                                                                                            -work tx_eth_gmii_encoder                                                                            
  vlog  "$QSYS_SIMDIR/submodules/altera_dcfifo_synchronizer_bundle.v"                                                                                -work tx_eth_gmii_encoder                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_10gmem_statistics_collector.v"                                                                     -work tx_eth_statistics_collector                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_tx_st_timing_adapter_splitter_status_output.v"      -work tx_st_timing_adapter_splitter_status_output                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_tx_st_timing_adapter_splitter_status_in.v"          -work tx_st_timing_adapter_splitter_status_in                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_tx_st_error_adapter_stat.v"                         -work tx_st_error_adapter_stat                                                                       
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_frame_decoder.v"                                                                                   -work tx_eth_frame_decoder                                                                           
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_stage.sv"                                                                                 -work tx_eth_frame_decoder                                                                           
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_base.v"                                                                                   -work tx_eth_frame_decoder                                                                           
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_tx_st_timing_adapter_frame_decoder.v"               -work tx_st_timing_adapter_frame_decoder                                                             
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_splitter.sv"                                                                                       -work tx_st_splitter_1                                                                               
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_stage.sv"                                                                                 -work tx_st_pipeline_stage_rs                                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_base.v"                                                                                   -work tx_st_pipeline_stage_rs                                                                        
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_crc.v"                                                                                             -work tx_eth_crc_inserter                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/crc32.v"                                                                                                      -work tx_eth_crc_inserter                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/gf_mult32_kc.v"                                                                                               -work tx_eth_crc_inserter                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_address_inserter.v"                                                                                -work tx_eth_address_inserter                                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_tx_st_mux_flow_control_user_frame.v"                -work tx_st_mux_flow_control_user_frame                                                              
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac_tx_st_pause_ctrl_error_adapter.v"                   -work tx_st_pause_ctrl_error_adapter                                                                 
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_pause_ctrl_gen.v"                                                                                  -work tx_eth_pause_ctrl_gen                                                                          
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_pause_controller.v"                                                                                -work tx_eth_pause_ctrl_gen                                                                          
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_pause_gen.v"                                                                                       -work tx_eth_pause_ctrl_gen                                                                          
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_pause_beat_conversion.v"                                                                           -work tx_eth_pause_beat_conversion                                                                   
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_pkt_backpressure_control.v"                                                                        -work tx_eth_pkt_backpressure_control                                                                
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_pad_inserter.v"                                                                                    -work tx_eth_pad_inserter                                                                            
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_packet_underflow_control.v"                                                                        -work tx_eth_packet_underflow_control                                                                
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_rs_demux.v"                                                                                        -work tx_st_mux_avst_2_rs_layer                                                                      
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_eth_10g_tx_register_map.v"                                                                             -work tx_register_map                                                                                
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_clock_crosser.v"                                                                                   -work tx_register_map                                                                                
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_mm_bridge.v"                                                                                          -work tx_bridge                                                                                      
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_handshake_clock_crosser.v"                                                                         -work crosser                                                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_clock_crosser.v"                                                                                   -work crosser                                                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_base.v"                                                                                   -work crosser                                                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv"                                                                                        -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_rsp_xbar_mux.sv"                                                -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_rsp_xbar_demux.sv"                                              -work rsp_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_cmd_xbar_demux.sv"                                              -work cmd_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_id_router.sv"                                                   -work id_router                                                                                      
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_addr_router.sv"                                                 -work addr_router                                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_fifo_pause_ctrl_adapter.v"                                                                               -work eth_fifo_pause_ctrl_adapter                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_pa_pg_after_timing_adapter.v"                                   -work pa_pg_after_timing_adapter                                                                     
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_pa_pg_before_timing_adapter.v"                                  -work pa_pg_before_timing_adapter                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_dc_fifo.v"                                                                                            -work dc_fifo_pause_adapt_pause_gen                                                                  
  vlog  "$QSYS_SIMDIR/submodules/altera_dcfifo_synchronizer_bundle.v"                                                                                -work dc_fifo_pause_adapt_pause_gen                                                                  
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_loopback_composed.v"                                        -work eth_loopback_composed                                                                          
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2_eth_10g_mac.v"                                                  -work eth_10g_mac                                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv"                                                                                        -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_rsp_xbar_mux.sv"                                                                         -work rsp_xbar_mux                                                                                   
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_rsp_xbar_demux.sv"                                                                       -work rsp_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_cmd_xbar_demux.sv"                                                                       -work cmd_xbar_demux                                                                                 
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_traffic_limiter.sv"                                                                                   -work limiter                                                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_base.v"                                                                                   -work limiter                                                                                        
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_id_router.sv"                                                                            -work id_router                                                                                      
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_addr_router.sv"                                                                          -work addr_router                                                                                    
  vlog  "$QSYS_SIMDIR/submodules/altera_avalon_sc_fifo.v"                                                                                            -work xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent_rsp_fifo                  
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_slave_agent.sv"                                                                                       -work xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent                           
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_burst_uncompressor.sv"                                                                                -work xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent                           
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_master_agent.sv"                                                                                      -work merlin_master_translator_0_avalon_universal_master_0_translator_avalon_universal_master_0_agent
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_slave_translator.sv"                                                                                  -work xcvr_10gbase_kr_2_phy_mgmt_translator                                                          
  vlog  "$QSYS_SIMDIR/submodules/altera_reset_controller.v"                                                                                          -work reset_controller_mac_rx_2                                                                      
  vlog  "$QSYS_SIMDIR/submodules/altera_reset_synchronizer.v"                                                                                        -work reset_controller_mac_rx_2                                                                      
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_eth_10g_design_example_2.v"                                                              -work eth_10g_design_example_2                                                                       
  vlog  "$QSYS_SIMDIR/submodules/altera_xcvr_functions.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_pcs.sv"                                                                                                          -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_pcs_ch.sv"                                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_pma.sv"                                                                                                          -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_reconfig_bundle_to_xcvr.sv"                                                                                      -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_reconfig_bundle_to_ip.sv"                                                                                        -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_reconfig_bundle_merger.sv"                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_rx_pma.sv"                                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_tx_pma.sv"                                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_tx_pma_ch.sv"                                                                                                    -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_xcvr_h.sv"                                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_xcvr_avmm_csr.sv"                                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_xcvr_avmm_dcd.sv"                                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_xcvr_avmm.sv"                                                                                                    -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_xcvr_data_adapter.sv"                                                                                            -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_xcvr_native.sv"                                                                                                  -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_xcvr_plls.sv"                                                                                                    -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/alt_xcvr_resync.sv"                                                                                                 -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_10g_rx_pcs_rbc.sv"                                                                                          -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_10g_tx_pcs_rbc.sv"                                                                                          -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_8g_rx_pcs_rbc.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_8g_tx_pcs_rbc.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_8g_pcs_aggregate_rbc.sv"                                                                                    -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_common_pcs_pma_interface_rbc.sv"                                                                            -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_common_pld_pcs_interface_rbc.sv"                                                                            -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_pipe_gen1_2_rbc.sv"                                                                                         -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_pipe_gen3_rbc.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_rx_pcs_pma_interface_rbc.sv"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_rx_pld_pcs_interface_rbc.sv"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_tx_pcs_pma_interface_rbc.sv"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/sv_hssi_tx_pld_pcs_interface_rbc.sv"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/altera_xcvr_native_sv_functions_h.sv"                                                                               -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/altera_xcvr_native_sv.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/alt_xcvr_csr_common_h.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/alt_xcvr_csr_common.sv"                                                                                             -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/alt_xcvr_csr_selector.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/altera_wait_generate.v"                                                                                             -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/csr_pcs10gbaser_h.sv"                                                                                               -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/csr_pcs10gbaser.sv"                                                                                                 -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_10gbaser_phy_params.sv"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_10gbaser_phy_clockcomp.sv"                                                                             -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_10gbaser_phy_async_fifo.sv"                                                                            -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_10gbaser_phy_1588_latency.sv"                                                                          -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_10gbaser_phy_rx_fifo_wrap.v"                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_10gbaser_phy_rx_fifo.v"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/altera_10gbaser_phy_async_fifo_fpga.sv"                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/csr_krtop_h.sv"                                                                                                     -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/csr_kran.sv"                                                                                                        -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/csr_krlt.sv"                                                                                                        -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/csr_krgige.sv"                                                                                                      -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/csr_krtop.sv"                                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/altera_xcvr_10gbase_kr.sv"                                                                                          -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_a_fifo_24.v"                                                                                      -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_carrier_sense.v"                                                                                  -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_colision_detect.v"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_gray_cnt.v"                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_gxb_aligned_rxsync.v"                                                                             -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_mdio_reg.v"                                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_mii_rx_if_pcs.v"                                                                                  -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_mii_tx_if_pcs.v"                                                                                  -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_pcs_control.v"                                                                                    -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_pcs_host_control.v"                                                                               -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_reset_synchronizer.v"                                                                             -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_rx_converter.v"                                                                                   -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_rx_encapsulation_strx_gx.v"                                                                       -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_rx_fifo_rd.v"                                                                                     -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_sdpm_altsyncram.v"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_sgmii_clk_enable.v"                                                                               -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_top.sv"                                                                                           -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_clock_crosser.v"                                                                                  -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_ph_calculator.sv"                                                                                 -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_top_1000_base_x_strx_gx.v"                                                                        -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_top_autoneg.v"                                                                                    -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_top_pcs_strx_gx.v"                                                                                -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_top_rx_converter.v"                                                                               -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_top_sgmii_strx_gx.v"                                                                              -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_top_tx_converter.v"                                                                               -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_tx_converter.v"                                                                                   -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/aldec/kr_gige_pcs_tx_encapsulation.v"                                                                               -work xcvr_10gbase_kr_2                                                                              
  vlog  "$QSYS_SIMDIR/submodules/altera_xcvr_functions.sv"                                                                                           -work xcvr_reset_control_2                                                                           
  vlog  "$QSYS_SIMDIR/submodules/alt_xcvr_resync.sv"                                                                                                 -work xcvr_reset_control_2                                                                           
  vlog  "$QSYS_SIMDIR/submodules/altera_xcvr_reset_control.sv"                                                                                       -work xcvr_reset_control_2                                                                           
  vlog  "$QSYS_SIMDIR/submodules/alt_xcvr_reset_counter.sv"                                                                                          -work xcvr_reset_control_2                                                                           
  vlog  "$QSYS_SIMDIR/submodules/altera_merlin_master_translator.sv"                                                                                 -work merlin_master_translator_0                                                                     
  vlog  "$QSYS_SIMDIR/submodules/altera_eth_10g_mac_base_kr_pll_0.vo"                                                                                -work pll_0                                                                                          
  vlog  "$QSYS_SIMDIR/altera_eth_10g_mac_base_kr.v"                                                                                                                                                                                                       
}

# ----------------------------------------
# Elaborate top level design
alias elab {
  echo "\[exec\] elab"
  vsim +access +r  -t ps -L work -L rsp_xbar_mux -L rsp_xbar_demux -L cmd_xbar_demux -L id_router -L addr_router -L lc_lb_timing_adapter -L line_splitter_timing_adapter -L line_lb_timing_adapter -L line_loopback -L lc_splitter_timing_adapter -L rsp_xbar_mux_002 -L rsp_xbar_demux_010 -L cmd_xbar_demux_002 -L rsp_xbar_mux_001 -L rsp_xbar_demux_002 -L cmd_xbar_demux_001 -L id_router_010 -L addr_router_002 -L id_router_002 -L addr_router_001 -L rxtx_timing_adapter_pauselen_tx -L rxtx_timing_adapter_pauselen_rx -L txrx_timing_adapter_link_fault_status_export -L txrx_timing_adapter_link_fault_status_rx -L rx_st_mux_rs_layer_2_avst -L rx_eth_gmii_decoder -L rx_st_error_adapter_stat -L rx_st_status_output_delay -L rx_eth_packet_overflow_control -L rx_eth_crc_pad_rem -L rx_eth_frame_status_merger -L rx_timing_adapter_frame_status_out_frame_decoder -L rx_st_timing_adapter_frame_status_in -L rx_eth_lane_decoder -L rx_eth_link_fault_detection -L rx_st_timing_adapter_lane_decoder -L rx_st_timing_adapter_interface_conversion -L rx_register_map -L tx_eth_link_fault_generation -L tx_eth_xgmii_termination -L tx_eth_packet_formatter -L tx_eth_gmii_encoder -L tx_eth_statistics_collector -L tx_st_timing_adapter_splitter_status_output -L tx_st_timing_adapter_splitter_status_in -L tx_st_error_adapter_stat -L tx_eth_frame_decoder -L tx_st_timing_adapter_frame_decoder -L tx_st_splitter_1 -L tx_st_pipeline_stage_rs -L tx_eth_crc_inserter -L tx_eth_address_inserter -L tx_st_mux_flow_control_user_frame -L tx_st_pause_ctrl_error_adapter -L tx_eth_pause_ctrl_gen -L tx_eth_pause_beat_conversion -L tx_eth_pkt_backpressure_control -L tx_eth_pad_inserter -L tx_eth_packet_underflow_control -L tx_st_mux_avst_2_rs_layer -L tx_register_map -L tx_bridge -L crosser -L eth_fifo_pause_ctrl_adapter -L pa_pg_after_timing_adapter -L pa_pg_before_timing_adapter -L dc_fifo_pause_adapt_pause_gen -L eth_loopback_composed -L eth_10g_mac -L limiter -L xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent_rsp_fifo -L xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent -L merlin_master_translator_0_avalon_universal_master_0_translator_avalon_universal_master_0_agent -L xcvr_10gbase_kr_2_phy_mgmt_translator -L reset_controller_mac_rx_2 -L eth_10g_design_example_2 -L xcvr_10gbase_kr_2 -L xcvr_reset_control_2 -L merlin_master_translator_0 -L pll_0 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L stratixv_ver -L stratixv_hssi_ver -L stratixv_pcie_hip_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Elaborate the top level design with -dbg -O2 option
alias elab_debug {
  echo "\[exec\] elab_debug"
  vsim -dbg -O2 +access +r -t ps -L work -L rsp_xbar_mux -L rsp_xbar_demux -L cmd_xbar_demux -L id_router -L addr_router -L lc_lb_timing_adapter -L line_splitter_timing_adapter -L line_lb_timing_adapter -L line_loopback -L lc_splitter_timing_adapter -L rsp_xbar_mux_002 -L rsp_xbar_demux_010 -L cmd_xbar_demux_002 -L rsp_xbar_mux_001 -L rsp_xbar_demux_002 -L cmd_xbar_demux_001 -L id_router_010 -L addr_router_002 -L id_router_002 -L addr_router_001 -L rxtx_timing_adapter_pauselen_tx -L rxtx_timing_adapter_pauselen_rx -L txrx_timing_adapter_link_fault_status_export -L txrx_timing_adapter_link_fault_status_rx -L rx_st_mux_rs_layer_2_avst -L rx_eth_gmii_decoder -L rx_st_error_adapter_stat -L rx_st_status_output_delay -L rx_eth_packet_overflow_control -L rx_eth_crc_pad_rem -L rx_eth_frame_status_merger -L rx_timing_adapter_frame_status_out_frame_decoder -L rx_st_timing_adapter_frame_status_in -L rx_eth_lane_decoder -L rx_eth_link_fault_detection -L rx_st_timing_adapter_lane_decoder -L rx_st_timing_adapter_interface_conversion -L rx_register_map -L tx_eth_link_fault_generation -L tx_eth_xgmii_termination -L tx_eth_packet_formatter -L tx_eth_gmii_encoder -L tx_eth_statistics_collector -L tx_st_timing_adapter_splitter_status_output -L tx_st_timing_adapter_splitter_status_in -L tx_st_error_adapter_stat -L tx_eth_frame_decoder -L tx_st_timing_adapter_frame_decoder -L tx_st_splitter_1 -L tx_st_pipeline_stage_rs -L tx_eth_crc_inserter -L tx_eth_address_inserter -L tx_st_mux_flow_control_user_frame -L tx_st_pause_ctrl_error_adapter -L tx_eth_pause_ctrl_gen -L tx_eth_pause_beat_conversion -L tx_eth_pkt_backpressure_control -L tx_eth_pad_inserter -L tx_eth_packet_underflow_control -L tx_st_mux_avst_2_rs_layer -L tx_register_map -L tx_bridge -L crosser -L eth_fifo_pause_ctrl_adapter -L pa_pg_after_timing_adapter -L pa_pg_before_timing_adapter -L dc_fifo_pause_adapt_pause_gen -L eth_loopback_composed -L eth_10g_mac -L limiter -L xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent_rsp_fifo -L xcvr_10gbase_kr_2_phy_mgmt_translator_avalon_universal_slave_0_agent -L merlin_master_translator_0_avalon_universal_master_0_translator_avalon_universal_master_0_agent -L xcvr_10gbase_kr_2_phy_mgmt_translator -L reset_controller_mac_rx_2 -L eth_10g_design_example_2 -L xcvr_10gbase_kr_2 -L xcvr_reset_control_2 -L merlin_master_translator_0 -L pll_0 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L stratixv_ver -L stratixv_hssi_ver -L stratixv_pcie_hip_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Compile all the design files and elaborate the top level design
alias ld "
  dev_com
  com
  elab
"

# ----------------------------------------
# Compile all the design files and elaborate the top level design with -dbg -O2
alias ld_debug "
  dev_com
  com
  elab_debug
"

# ----------------------------------------
# Print out user commmand line aliases
alias h {
  echo "List Of Command Line Aliases"
  echo
  echo "dev_com                       -- Compile device library files"
  echo
  echo "com                           -- Compile the design files in correct order"
  echo
  echo "elab                          -- Elaborate top level design"
  echo
  echo "elab_debug                    -- Elaborate the top level design with -dbg -O2 option"
  echo
  echo "ld                            -- Compile all the design files and elaborate the top level design"
  echo
  echo "ld_debug                      -- Compile all the design files and elaborate the top level design with -dbg -O2"
  echo
  echo 
  echo
  echo "List Of Variables"
  echo
  echo "TOP_LEVEL_NAME                -- Top level module name."
  echo
  echo "SYSTEM_INSTANCE_NAME          -- Instantiated system module name inside top level module."
  echo
  echo "QSYS_SIMDIR                   -- Qsys base simulation directory."
}
h
