#**************************************************************
# Time Information
#**************************************************************

set_time_format -unit ns -decimal_places 3



#**************************************************************
# Create Clock
#**************************************************************


create_clock -name {mm_clk} -period 10.000 -waveform { 0.000 5.000 } [get_ports {mm_clk}]
create_clock -name {ref_clk_322} -period 3.105 -waveform { 0.000 1.552 } [get_ports {ref_clk_322}]
create_clock -name {ref_clk_125} -period 8.000 -waveform { 0.000 4.000 } [get_ports {ref_clk_125}]


derive_pll_clocks
derive_clock_uncertainty


# Since default compilation mode is based on 10G, thus we need to create 1G clock based on same node to ensure timing analysis are done on appropriate clock domain and logic
# Create 1G clock
if ![info exists INST_HIERARCHY] { 
  set INST_HIERARCHY DUT
} 

#**************************************************************
# Create Generated Clock
# since by default the system is running at 10G, hence need to create clk_8g,clk_8g_tx and tx_clkout_8g to analyse the # 1G path. 
#**************************************************************

#create_generated_clock -name clk_8g -source [get_ports {ref_clk_125}] -divide_by 1 -multiply_by 1 -duty_cycle 50 -phase 0 -offset 0 {*|altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|rx_pma.sv_rx_pma_inst|rx_pmas[0].rx_pma.rx_pma_deser|clk90b} -add

#remove_clock {{*SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pcs|ch[0].inst_sv_pcs_ch|inst_sv_hssi_8g_tx_pcs|wys|clkout}}

#create_clock  -name tx_clkout_8g -period 8 -waveform {0 4} [get_nets {*SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pcs|ch[0].inst_sv_pcs_ch|inst_sv_hssi_8g_tx_pcs|clkout}] 


# Configure TX clkout
#remove_clock "$INST_HIERARCHY|xcvr_10gbase_kr_0|SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pcs|ch[0].inst_sv_pcs_ch|inst_sv_hssi_8g_tx_pcs|wys|clkout"
#remove_clock "$INST_HIERARCHY|xcvr_10gbase_kr_1|SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pcs|ch[0].inst_sv_pcs_ch|inst_sv_hssi_8g_tx_pcs|wys|clkout"

#create_clock  -name tx_clkout_8g -period 8 -waveform {0 4} [get_nets {altera_eth_1g_10g_design_example_inst|a_1g_10g_ethernet_wrapper_0|altera_1g_10g_generic_wrapper_inst|altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pcs|ch[0].inst_sv_pcs_ch|inst_stratixv_hssi_8g_tx_pcs|clkout}] 


#create_generated_clock -name tx_pma_clk_1g_0 -add -source "$INST_HIERARCHY|xcvr_10gbase_kr_0|GIGE_ENABLE.PLL_1G.tx_pll_1g|pll[0].pll.cmu_pll.tx_pll|refclk" -divide_by 1 -multiply_by 1 -duty_cycle 50 -phase 0 -offset 0 "$INST_HIERARCHY|xcvr_10gbase_kr_0|SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|tx_pma.sv_tx_pma_inst|tx_pma_insts[0].sv_tx_pma_ch_inst|tx_pma_ch.tx_cgb|pclk[1]"
#create_generated_clock -name tx_pma_clk_1g_1 -add -source "$INST_HIERARCHY|xcvr_10gbase_kr_1|GIGE_ENABLE.PLL_1G.tx_pll_1g|pll[0].pll.cmu_pll.tx_pll|refclk" -divide_by 1 -multiply_by 1 -duty_cycle 50 -phase 0 -offset 0 "$INST_HIERARCHY|xcvr_10gbase_kr_1|SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|tx_pma.sv_tx_pma_inst|tx_pma_insts[0].sv_tx_pma_ch_inst|tx_pma_ch.tx_cgb|pclk[1]"



#create_generated_clock -name clk_8g_tx -source {ref_clk_125} -divide_by 1 -multiply_by 1 -duty_cycle 50 -phase 0 -offset 0 {altera_eth_1g_10g_design_example_inst|a_1g_10g_ethernet_wrapper_0|altera_1g_10g_generic_wrapper_inst|altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|tx_pma.sv_tx_pma_inst|tx_pma_insts[0].sv_tx_pma_ch_inst|tx_pma_ch.tx_cgb|pclk[1]} -add
#
#set_clock_groups -asynchronous -group clk_8g_tx -group [get_clocks {altera_eth_1g_10g_design_example_inst|a_1g_10g_ethernet_wrapper_0|altera_1g_10g_generic_wrapper_inst|altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|tx_pma.sv_tx_pma_inst|tx_pma_insts[0].sv_tx_pma_ch_inst|tx_pma_ch.tx_cgb|pclk[1]} ]


#**************************************************************
# Set Clock Latency
#**************************************************************



#**************************************************************
# Set Clock Uncertainty
#**************************************************************




#**************************************************************
# Set Input Delay
#**************************************************************



#**************************************************************
# Set Output Delay
#**************************************************************



#**************************************************************
# Set Clock Groups
#**************************************************************

set_clock_groups -asynchronous -group [get_clocks mm_clk]
#set_clock_groups -asynchronous -group clk_8g -group [get_clocks {*|altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|rx_pma.sv_rx_pma_inst|rx_pmas[0].rx_pma.rx_pma_deser|clk90b} ]



# False path between 1G clock and 10G clock
#set_clock_groups -asynchronous -group [get_clocks {*|xcvr_10gbase_kr_0|SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|tx_pma.sv_tx_pma_inst|tx_pma_insts[0].sv_tx_pma_ch_inst|tx_pma_ch.tx_cgb|pclk[1]}] -group [get_clocks tx_pma_clk_1g_0]
#set_clock_groups -asynchronous -group [get_clocks {*|xcvr_10gbase_kr_1|SV_NATIVE.altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|tx_pma.sv_tx_pma_inst|tx_pma_insts[0].sv_tx_pma_ch_inst|tx_pma_ch.tx_cgb|pclk[1]}] -group [get_clocks tx_pma_clk_1g_1]
#**************************************************************
# Set False Path
#**************************************************************
set_false_path -from [get_registers {*eth_loopback_composed|altera_avalon_dc_fifo:dc_fifo_2|out_payload[*]}] -to [get_registers {*inst_sv_pcs|sv_pcs_ch:ch[*].inst_sv_pcs_ch|sv_hssi_8g_tx_pcs_rbc:inst_sv_hssi_8g_tx_pcs|syncdatain}]
set_false_path -from [get_registers {*eth_loopback_composed|altera_eth_loopback:line_loopback|*}] -to [get_registers {*inst_sv_pcs|sv_pcs_ch:ch[*].inst_sv_pcs_ch|sv_hssi_8g_tx_pcs_rbc:inst_sv_hssi_8g_tx_pcs|syncdatain}]
set_false_path -from {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_rx_pcs_rbc:inst_sv_hssi_8g_rx_pcs|syncdatain} -to {*:eth_10g_mac|altera_eth_link_fault_detection:rx_eth_link_fault_detection|*}
set_false_path -from {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_rx_pcs_rbc:inst_sv_hssi_8g_rx_pcs|syncdatain} -to {*:eth_loopback_composed|altera_avalon_dc_fifo:dc_fifo_2|*}
set_false_path -from {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_rx_pcs_rbc:inst_sv_hssi_8g_rx_pcs|syncdatain} -to {*:eth_10g_mac|altera_eth_lane_decoder:*}

																																																																																																																						

set_false_path -from {*} -to {*resync:*}
set_false_path -from {*} -to {*sld_signaltap:auto_signaltap_0*}
# KR GIGE PCS false paths
set_false_path -from [get_registers {*|kr_gige_pcs_a_fifo_24:U_DSW|kr_gige_pcs_gray_cnt:U_RD|g_out[*]}] -to [get_registers {*|kr_gige_pcs_a_fifo_24:U_DSW|rd_g_wptr[*]}]
set_false_path -from [get_registers {*|kr_gige_pcs_a_fifo_24:U_DSW|kr_gige_pcs_gray_cnt:U_RD|b_out[*]}] -to [get_registers {*|kr_gige_pcs_a_fifo_24:U_DSW|rd_g_wptr[*]}]
set_false_path -from [get_registers {*|kr_gige_pcs_a_fifo_24:U_DSW|kr_gige_pcs_gray_cnt:U_WRT|g_out[*]}] -to [get_registers {*|kr_gige_pcs_a_fifo_24:U_DSW|wr_g_rptr[*]}]

#set_false_path -from [get_registers {*|kr_gige_pcs_top_sgmii:U_SGMII|kr_gige_pcs_colision_detect:U_COL|state*}] -to [get_registers {*|kr_gige_pcs_fifoless_mac_tx:U_TX|gm_rx_col_reg*}]
#set_false_path -from [get_registers {*|kr_gige_pcs_a_fifo_34:RX_STATUS|wr_g_ptr_reg[*]}] -to [get_registers {*|kr_gige_pcs_a_fifo_34:RX_STATUS|wr_g_rptr[*]}]

# False path between GIGE PCS and 10g PCS **
set_false_path -from [get_keepers {*|kr_gige_pcs_top:GIGE_ENABLE.GMII_PCS_ENABLED.kr_gige_pcs_top|*}] -to [get_keepers {*|altera_xcvr_10gbase_kr:xcvr_10gbase_kr_*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_10g_tx_pcs_rbc:inst_sv_hssi_10g_tx_pcs|syncdatain}]
set_false_path -from [get_keepers {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_10g_rx_pcs_rbc:inst_sv_hssi_10g_rx_pcs|syncdatain}] -to [get_keepers {*|kr_gige_pcs_top:GIGE_ENABLE.GMII_PCS_ENABLED.kr_gige_pcs_top|*} ]

# False path from 322 clock to to GIGE PCS **
set_false_path -from [get_clocks {ref_clk_322}] -to [get_registers {*|kr_gige_pcs_top:GIGE_ENABLE.GMII_PCS_ENABLED.kr_gige_pcs_top|*}]

#False path between clk8g and clk10g and XXclk90
#set_false_path -from [get_clocks {*altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|rx_pma.sv_rx_pma_inst|rx_pmas[0].rx_pma.rx_pma_deser|clk90b}] -to clk_8g
#set_false_path -from clk_8g -to [get_clocks {*altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|rx_pma.sv_rx_pma_inst|rx_pmas[0].rx_pma.rx_pma_deser|clk90b}] 


set_false_path -from {*|altera_eth_link_fault_generation:tx_eth_link_fault_generation|mii_src_column_data[*][*][*]} -to [get_registers {*inst_sv_pcs|sv_pcs_ch:ch[*].inst_sv_pcs_ch|sv_hssi_8g_tx_pcs_rbc:inst_sv_hssi_8g_tx_pcs|syncdatain}]

set_false_path -from {*|kr_gige_pcs_top:GIGE_ENABLE.GMII_PCS_ENABLED.kr_gige_pcs_top|kr_gige_pcs_top_1000_base_x_strx_gx:kr_gige_pcs_top_1000_base_x_strx_gx_inst|kr_gige_pcs_top_sgmii_strx_gx:U_SGMII|kr_gige_pcs_top_pcs_strx_gx:U_PCS|kr_gige_pcs_rx_encapsulation_strx_gx:U_RCAPS|gmii_dv} -to {*|kr_gige_pcs_top:GIGE_ENABLE.GMII_PCS_ENABLED.kr_gige_pcs_top|kr_gige_pcs_top_1000_base_x_strx_gx:kr_gige_pcs_top_1000_base_x_strx_gx_inst|kr_gige_pcs_top_sgmii_strx_gx:U_SGMII|kr_gige_pcs_top_rx_converter:U_RXCV|kr_gige_pcs_rx_fifo_rd:U_FFRD|pcs_dv_macclk}

# False path from XXXXclk90 to to GIGE PCS
set_false_path -from [get_clocks {*altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|rx_pma.sv_rx_pma_inst|rx_pmas[0].rx_pma.rx_pma_deser|clk90b}] -to [get_registers {*kr_gige_pcs_top*}]

set_false_path -from [get_clocks {*altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|rx_pma.sv_rx_pma_inst|rx_pmas[0].rx_pma.rx_pma_deser|clk90b}] -to [get_registers {*kr_gige_pcs_top*}]

# False path from XXXXclk90 to to 8G PCS
set_false_path -from [get_clocks {*altera_xcvr_native_sv_inst|gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|inst_sv_pma|rx_pma.sv_rx_pma_inst|rx_pmas[0].rx_pma.rx_pma_deser|clk90b}] -to [get_registers {*sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_*}]

# False path from clk_8g to to 10G PCS
#set_false_path -from clk_8g -to [get_registers {*sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_10g_*}]

# False path between 10G and Gige sync FSM
#set_false_path -from {*xgmii_src*} -to {*|altera_xcvr_native_sv:altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|stratixv_hssi_8g_tx_pcs_rbc:inst_stratixv_hssi_8g_tx_pcs*}


set_false_path -from  {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_rx_pcs_rbc:inst_sv_hssi_8g_rx_pcs|syncdatain*} -to {*|altera_xcvr_10gbase_kr:xcvr_10gbase_kr_*|an_top:AN_GEN.AUTO_NEG|an_decode:*}
set_false_path -from  {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_rx_pcs_rbc:inst_sv_hssi_8g_rx_pcs|syncdatain*} -to {*|altera_xcvr_10gbase_kr:xcvr_10gbase_kr_*|lt_top:LT_GEN.LINK_TRAIN|*}
set_false_path -from  {*|altera_xcvr_10gbase_kr:xcvr_10gbase_kr_*|an_top:AN_GEN.AUTO_NEG|*} -to {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_tx_pcs_rbc:inst_sv_hssi_8g_tx_pcs|syncdatain}
set_false_path -from  {*|altera_xcvr_10gbase_kr:xcvr_10gbase_kr_*|lt_top:LT_GEN.LINK_TRAIN|lt_tx_gbx:TX_GEARBOX*} -to {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_8g_tx_pcs_rbc:inst_sv_hssi_8g_tx_pcs|syncdatain}

############ NEW FALSE PATHS
set_false_path -from {*sv_xcvr_avmm*}
set_false_path -to   {*sv_xcvr_avmm*}
set_false_path -to   {*altera_reserved_tck*}
set_false_path -from {*altera_reserved_tck*}
set_false_path -from [get_clocks {*clk33pcs*} ] -to {*altera_eth_10g_mac_base_kr_eth_10g_design_example_0:eth_10g_design_example_0|altera_eth_10g_mac_base_kr_eth_10g_design_example_0_eth_10g_mac*}
set_false_path -from [get_clocks {*clk33pcs*}] -through [get_nets {*inst_sv_hssi_10g_rx_pcs*}] -to [get_registers {*altera_eth_10g_mac_base_kr_eth_10g_design_example_*:eth_10g_design_example_*|altera_eth_10g_mac_base_kr_eth_10g_design_example_0_eth_10g_mac*}]
set_false_path -from  {*clk33pcs*} -to {*pll_0*divclk*}
set_false_path -from [get_clocks {*pll_0*divclk*}] -to [get_registers {*an_top:AN_GEN.AUTO_NEG|an_decode:DECODE|dme_dly[*]*}]
set_false_path -from [get_clocks {*pll_0*divclk*}] -to [get_registers {*lt_top:LT_GEN.LINK_TRAIN|lt_rx_gbx:RX_GEARBOX*}]

set_false_path -from [get_registers {*|csr_pcs10gbaser:csr_10gpcs|sync_rclr_errblk_cnt*}] -to [get_registers {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_10g_rx_pcs_rbc:inst_sv_hssi_10g_rx_pcs|wys*}]
set_false_path -from [get_registers {*|csr_pcs10gbaser:csr_10gpcs|sync_rclr_ber_cnt*}] -to [get_registers {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_10g_rx_pcs_rbc:inst_sv_hssi_10g_rx_pcs|wys*}]
set_false_path -from [get_registers {*|lt_top:LT_GEN.LINK_TRAIN|lt_frame_lock:LOCK_SM|bs_shifter*}] -to [get_registers {*|altera_xcvr_native_sv:SV_NATIVE.altera_xcvr_native_sv_inst|sv_xcvr_native:gen_native_inst.xcvr_native_insts[0].gen_bonded_group_native.xcvr_native_inst|sv_pcs:inst_sv_pcs|sv_pcs_ch:ch[0].inst_sv_pcs_ch|sv_hssi_10g_rx_pcs_rbc:inst_sv_hssi_10g_rx_pcs|wys*}]





set_clock_groups -exclusive -group [get_clocks {*clk33pcs*} ] -group [get_clocks {*pll_0*divclk*} ]
# False path CH1 for now --ALL



#**************************************************************
# Set Multicycle Path
#**************************************************************



#**************************************************************
# Set Maximum Delay
#**************************************************************



#**************************************************************
# Set Minimum Delay
#**************************************************************



#**************************************************************
# Set Input Transition
#**************************************************************

