module altera_eth_10g_mac_base_kr_top(
    
    // clock and reset
    input                   mm_clk,
   
    
    input                   ref_clk_125,
    input                   ref_clk_322,
    input                   reset_n,
   

	
    
    //  serial data
    input                   ch2_rx_serial_data,
    output                  ch2_tx_serial_data,
  
    
    output              ch2_led_link_n,
    
   
    output              ch2_rx_data_ready_n,
    
    // SFP Cage Interface
    input wire          SFPP_TX_FAULT,
    input wire          SFPP_RX_LOS,
    input wire          SFPP_MOD_ABS,
    output wire         SFPP_TX_DIS,
    output wire [1:0]   SFPP_RATE_SEL,
    input               dip_rate_select,
    
    output [1:0]        led_status
  

);

   
    
    wire                xgmii_clk;
    
    // assign reset            = !reset_n;
    assign SFPP_RATE_SEL    = dip_rate_select ? 2'b01 : 2'b00; // SFPP_RATE_SEL[0] = 1 for 10G, 0 for 1G (Finisar SFP+)
    assign led_status       = dip_rate_select ? 2'b01 : 2'b10;
    assign SFPP_TX_DIS      = 0;
    

    
    wire            ch2_led_link;
                
   
    wire            ch2_rx_data_ready;
   
    assign ch2_led_link_n = !ch2_led_link;
    
   
    assign ch2_rx_data_ready_n = !ch2_rx_data_ready;
    
 


    wire                   avalon_st_tx_startofpacket;
    wire                   avalon_st_tx_endofpacket;
    wire                   avalon_st_tx_valid;
    wire                   avalon_st_tx_ready;
    wire   [63:0]          avalon_st_tx_data;
    wire   [2:0]           avalon_st_tx_empty;
    wire   [5:0]           avalon_st_tx_error;
     
    wire                   avalon_st_rx_startofpacket;
    wire                   avalon_st_rx_endofpacket;
    wire                   avalon_st_rx_valid;
    wire                   avalon_st_rx_ready;
    wire   [63:0]          avalon_st_rx_data;
    wire   [2:0]           avalon_st_rx_empty;
    wire   [5:0]           avalon_st_rx_error;

    
   
    
    wire                mm_reset_reset_n;
    
    assign mm_reset_reset_n = reset_n;

    
parameter	NUMSLAVES = 2;

    
 wire  					master_if_clk;				// master clock				//jier no use
wire [NUMSLAVES-1:0] 	slave_if_clk;				// slave clock 	      (s) 	//jier no use
wire [NUMSLAVES-1:0] 	slave_if_write;				// slave write 	      (s)
wire [NUMSLAVES-1:0] 	slave_if_read;				// slave read 	      (s)
wire [24*NUMSLAVES-1:0] slave_if_address;			// slave address      (s)   //but kr use 19:0
wire [32*NUMSLAVES-1:0] slave_if_writedata;			// slave writedata    (s)
wire [32*NUMSLAVES-1:0] slave_if_readdata;			// slave read 	      (s)
wire [NUMSLAVES-1:0] 	slave_if_readdata_valid;	// slave readvalid    (s)
wire [NUMSLAVES-1:0] 	slave_if_waitrequest;		// slave readvalid    (s)    
    
    
    
    wire                reset;
    wire                serial_data_ch0_to_ch1;
    wire                serial_data_ch1_to_ch0;
    wire    [71:0]      xgmii_tx_dc;
    wire    [71:0]      xgmii_rx_dc;
    wire                tx_pcfifo_error_1g_export;
    wire                rx_pcfifo_error_1g_export;

    wire    [15:0]      reconfig_mif_readdata;
    wire                reconfig_mif_read;
    wire    [15:0]      reconfig_mif_address;
    wire                reconfig_mif_waitrequest;



    wire                reconfig_mgmt_waitrequest;
    wire    [31:0]      reconfig_mgmt_writedata;
    wire                reconfig_mgmt_write;
    wire    [6:0]       reconfig_mgmt_address;
    wire    [31:0]      reconfig_mgmt_readdata;
    wire                reconfig_mgmt_read;
    wire                speed_sel;

 
    
    // reset controoler output
   
    wire                ch2_rst_cntlr_pll_powerdown;
    wire                ch2_rst_cntlr_tx_analogreset;
    wire                ch2_rst_cntlr_tx_digitalreset;
    wire                ch2_rst_cntlr_rx_analogreset;
    wire                ch2_rst_cntlr_rx_digitalreset;
    
    
    wire                ch2_rx_ready;
    wire                ch2_tx_ready;
    wire                ch2_reconfig_mgmt_busy;
    wire                reconfig_mgmt_busy;
    wire                reconfig_mgmt_busy2;

   
    
    wire [209:0]        ch2_reconfig_to_xcvr;
    wire [137:0]        ch2_reconfig_from_xcvr;
    
    
   
    wire                ch2_phy_pll_locked;
   
    wire                pll156M_locked;
   
   
    wire                ch2_hdsk_rc_busy;
    
   
    wire                ch2_baser_ll_mif_done;
    
   
    wire                ch2_mode_1g_10gbar;
    
    
   
    
  
    wire [5:0]          ch2_seq_pcs_mode;
    wire [5:0]          ch2_seq_pma_vod;
    wire [4:0]          ch2_seq_pma_postap1;
    wire [3:0]          ch2_seq_pma_pretap;
    wire [2:0]          ch2_tap_to_upd;
    wire                ch2_seq_start_rc;
    wire                ch2_lt_start_rc;
    wire                ch2_en_lcl_rxeq;
    wire                ch2_rxeq_done;
   
   
    
    wire 	            ch2_dmi_mode_en; 
    wire 	            ch2_dmi_frame_lock; 
    wire 	            ch2_dmi_rmt_rx_ready; 
    wire [5:0]          ch2_dmi_lcl_coefl; 
    wire [13:12]        ch2_dmi_lcl_coefh; 
    wire 	            ch2_dmi_lcl_upd_new; 
    wire 	            ch2_dmi_rx_trained; 
    wire 	            ch2_dmo_frame_lock; 
    wire 	            ch2_dmo_rmt_rx_ready; 
    wire [5:0]          ch2_dmo_lcl_coefl; 
    wire [13:12]        ch2_dmo_lcl_coefh; 
    wire 	            ch2_dmo_lcl_upd_new; 
    wire 	            ch2_dmo_rx_trained; 
    
   
    wire                ch2_rx_is_lockedtodata;
    
    
    
    wire                ch2_rx_syncstatus;
    
    wire                ch2_rx_sync_lock;
    
    
   

  
    wire 	            ch2_pll_locked;    
    wire 	            ch2_tx_cal_busy;    
    wire 	            ch2_rx_cal_busy;    
    wire 	            ch2_lcl_rf; // local device (MAC) Remote Fault = D13
    
   
    assign ch2_pll_locked = ch2_phy_pll_locked & pll156M_locked;
    assign  reset= !reset_n;
    
    wire    reconfig_busy2;



        altera_eth_10g_mac_base_kr DUT (
        //pll
        .pll_0_pll_locked_export                                (pll156M_locked),
        .pll_0_reset_reset                                      (reset),
        .clk_156_25_clk                                         (xgmii_clk),
          .reset_156_25_reset_n                                  (reset_n),
        // mm clock
        .mm_clk_clk                                             (mm_clk),
        .mm_reset_reset_n                                       (reset_n),
    
        //phy
        .ref_clk_10g_clk_clk                                    (ref_clk_322),
        .ref_clk_10g_reset_reset_n                              (reset_n),
        .ref_clk_1g_clk_clk                                     (ref_clk_125),
        .ref_clk_1g_reset_reset_n                               (reset_n),
    

        
        // phy channel 2
        .xcvr_10gbase_kr_2_pll_powerdown_10g_pll_powerdown_10g  (ch2_rst_cntlr_pll_powerdown),
        .xcvr_10gbase_kr_2_pll_powerdown_1g_pll_powerdown_1g    (ch2_rst_cntlr_pll_powerdown),
        .xcvr_10gbase_kr_2_tx_analogreset_tx_analogreset        (ch2_rst_cntlr_tx_analogreset),
        .xcvr_10gbase_kr_2_tx_digitalreset_tx_digitalreset      (ch2_rst_cntlr_tx_digitalreset),
        .xcvr_10gbase_kr_2_rx_analogreset_rx_analogreset        (ch2_rst_cntlr_rx_analogreset),
        .xcvr_10gbase_kr_2_rx_digitalreset_rx_digitalreset      (ch2_rst_cntlr_rx_digitalreset),
        .xcvr_10gbase_kr_2_usr_seq_reset_usr_seq_reset          (reset),
        .xcvr_10gbase_kr_2_rx_is_lockedtodata_export            (ch2_rx_is_lockedtodata),        
        .xcvr_10gbase_kr_2_tx_serial_data_export                (ch2_tx_serial_data),
        .xcvr_10gbase_kr_2_rx_serial_data_export                (ch2_rx_serial_data),
        .xcvr_10gbase_kr_2_tx_cal_busy_export                   (ch2_tx_cal_busy),
        .xcvr_10gbase_kr_2_rx_cal_busy_export                   (ch2_rx_cal_busy),
        .xcvr_10gbase_kr_2_led_link_export                      (ch2_led_link),
        .xcvr_10gbase_kr_2_led_an_export                        (),
        .xcvr_10gbase_kr_2_led_char_err_export                  (),
        .xcvr_10gbase_kr_2_led_disp_err_export                  (),
        .xcvr_10gbase_kr_2_tx_pcfifo_error_1g_export            (),
        .xcvr_10gbase_kr_2_rx_pcfifo_error_1g_export            (),
       
        .xcvr_10gbase_kr_2_rx_data_ready_export                 (ch2_rx_data_ready),
        
        .xcvr_10gbase_kr_2_tm_in_trigger_export                 (4'd0),
        .xcvr_10gbase_kr_2_tm_out_trigger_export                (),
        .xcvr_10gbase_kr_2_rc_busy_export                       (ch2_hdsk_rc_busy),
        .xcvr_10gbase_kr_2_rx_syncstatus_export                 (ch2_rx_syncstatus),
        .xcvr_10gbase_kr_2_rx_block_lock_export                 (),
        .xcvr_10gbase_kr_2_rx_hi_ber_export                     (),
        
        .xcvr_10gbase_kr_2_main_rc_export                       (ch2_seq_pma_vod),   
        .xcvr_10gbase_kr_2_post_rc_export                       (ch2_seq_pma_postap1),
        .xcvr_10gbase_kr_2_pre_rc_export                        (ch2_seq_pma_pretap),
        .xcvr_10gbase_kr_2_tap_to_upd_export                    (ch2_tap_to_upd),
        .xcvr_10gbase_kr_2_en_lcl_rxeq_export                   (ch2_en_lcl_rxeq),
        .xcvr_10gbase_kr_2_rxeq_done_export                     (1'b1),
        .xcvr_10gbase_kr_2_seq_start_rc_export                  (ch2_seq_start_rc), //temp
        .xcvr_10gbase_kr_2_pcs_mode_rc_export                   (ch2_seq_pcs_mode), //temp
        .xcvr_10gbase_kr_2_lcl_rf_export                        (1'b0),
        
        .xcvr_10gbase_kr_2_rx_rlv_export                        (),
        .xcvr_10gbase_kr_2_mode_1g_10gbar_export                (ch2_seq_pcs_mode[3]),
        .xcvr_10gbase_kr_2_pll_locked_export                    (ch2_phy_pll_locked),
        .xcvr_10gbase_kr_2_rx_clkslip_export                    (1'b0),

        .xcvr_10gbase_kr_2_reconfig_from_xcvr_reconfig_from_xcvr(ch2_reconfig_from_xcvr),
        .xcvr_10gbase_kr_2_reconfig_to_xcvr_reconfig_to_xcvr    (ch2_reconfig_to_xcvr),      
        
        
 
        
        
        // mac channel 2
        .eth_10g_design_example_2_speed_sel_export              (ch2_seq_pcs_mode[3]),
        .eth_10g_design_example_2_avalon_st_rxstatus_valid      (),
        .eth_10g_design_example_2_avalon_st_rxstatus_data       (),
        .eth_10g_design_example_2_avalon_st_rxstatus_error      (),
        .eth_10g_design_example_2_link_fault_status_xgmii_rx_data(),
        .eth_10g_design_example_2_tx_sc_fifo_in_data            (avalon_st_tx_data),                    
        .eth_10g_design_example_2_tx_sc_fifo_in_valid           (avalon_st_tx_valid),         
        .eth_10g_design_example_2_tx_sc_fifo_in_ready           (avalon_st_tx_ready),         
        .eth_10g_design_example_2_tx_sc_fifo_in_startofpacket   (avalon_st_tx_startofpacket), 
        .eth_10g_design_example_2_tx_sc_fifo_in_endofpacket     (avalon_st_tx_endofpacket),   
        .eth_10g_design_example_2_tx_sc_fifo_in_empty           (avalon_st_tx_empty),         
        //.eth_10g_design_example_2_tx_sc_fifo_in_error           (ch1_avalon_st_source_error[5]|ch1_avalon_st_source_error[4]|ch1_avalon_st_source_error[3]|ch1_avalon_st_source_error[2]|ch1_avalon_st_source_error[1]|ch1_avalon_st_source_error[0]),         
       .eth_10g_design_example_2_tx_sc_fifo_in_error					(avalon_st_tx_error),
		 .eth_10g_design_example_2_rx_sc_fifo_out_data           (avalon_st_rx_data),
        .eth_10g_design_example_2_rx_sc_fifo_out_valid          (avalon_st_rx_valid),
        .eth_10g_design_example_2_rx_sc_fifo_out_ready          (avalon_st_rx_ready),
        .eth_10g_design_example_2_rx_sc_fifo_out_startofpacket  (avalon_st_rx_startofpacket),
        .eth_10g_design_example_2_rx_sc_fifo_out_endofpacket    (avalon_st_rx_endofpacket),
        .eth_10g_design_example_2_rx_sc_fifo_out_empty          (avalon_st_rx_empty),
        .eth_10g_design_example_2_rx_sc_fifo_out_error          (avalon_st_rx_error),
        .eth_10g_design_example_2_avalon_st_txstatus_valid      (),
        .eth_10g_design_example_2_avalon_st_txstatus_data       (),
        .eth_10g_design_example_2_avalon_st_txstatus_error      (),
    
    
		// reset controller adapter
        .reset_controller_2_reset_in0_reset						(reset),					// universal reset
		.reset_controller_2_reset_in1_reset						(ch2_baser_ll_mif_done),		// baser_ll_mif_done

				
		.reset_controller_mac_rx_2_reset_in0_reset				(reset),
		.reset_controller_mac_rx_2_reset_in1_reset				(ch2_rst_cntlr_rx_digitalreset),
	
       .reset_controller_mac_tx_2_reset_in0_reset				(reset),
		.reset_controller_mac_tx_2_reset_in1_reset				(ch2_rst_cntlr_tx_digitalreset),
	
   
        // reset controller channel 2
        .xcvr_reset_control_2_pll_powerdown_pll_powerdown       (ch2_rst_cntlr_pll_powerdown),
        .xcvr_reset_control_2_tx_analogreset_tx_analogreset     (ch2_rst_cntlr_tx_analogreset),
        .xcvr_reset_control_2_tx_digitalreset_tx_digitalreset   (ch2_rst_cntlr_tx_digitalreset),
        .xcvr_reset_control_2_tx_ready_tx_ready                 (ch2_tx_ready),
        .xcvr_reset_control_2_pll_locked_pll_locked             (ch2_pll_locked),
        .xcvr_reset_control_2_pll_select_pll_select             (1'b0),
        .xcvr_reset_control_2_tx_cal_busy_tx_cal_busy           (ch2_tx_cal_busy),
        .xcvr_reset_control_2_rx_analogreset_rx_analogreset     (ch2_rst_cntlr_rx_analogreset),
        .xcvr_reset_control_2_rx_digitalreset_rx_digitalreset   (ch2_rst_cntlr_rx_digitalreset),
        .xcvr_reset_control_2_rx_ready_rx_ready                 (ch2_rx_ready),
        .xcvr_reset_control_2_rx_is_lockedtodata_rx_is_lockedtodata         (ch2_rx_is_lockedtodata),
        .xcvr_reset_control_2_rx_cal_busy_rx_cal_busy           (ch2_rx_cal_busy),
    
        


        .merlin_master_translator_0_avalon_anti_master_0_address    (slave_if_address[19:0]),    
        .merlin_master_translator_0_avalon_anti_master_0_waitrequest(slave_if_waitrequest[0]),
        .merlin_master_translator_0_avalon_anti_master_0_read       (slave_if_read[0]),       
        .merlin_master_translator_0_avalon_anti_master_0_readdata   (slave_if_readdata[31:0]),   
        .merlin_master_translator_0_avalon_anti_master_0_write      (slave_if_write[0]),      
        .merlin_master_translator_0_avalon_anti_master_0_writedata  (slave_if_writedata[31:0])   




        );
        

        
		  
		  
	 sys_control #(.NUMSLAVES (NUMSLAVES)) SYS_CONTROL (
	.reset_n							(reset_n),					// asynchronous reset 
	.master_if_clk						(mm_clk), 				// master clock       
`ifdef TWOPORTS
	.slave_if_clk						({xgmii_clk, mm_clk, mm_clk}),	// slave clock 	      (s) 
`else
	.slave_if_clk						({xgmii_clk, mm_clk}),	// slave clock 	      (s) 
`endif
	.slave_if_write						(slave_if_write),			// slave write 	      (s)
	.slave_if_read						(slave_if_read),			// slave read 	      (s)
	.slave_if_address					(slave_if_address),			// slave address      (s)
	.slave_if_writedata					(slave_if_writedata),		// slave writedata    (s)
	.slave_if_readdata					(slave_if_readdata),		// slave read 	      (s)
	.slave_if_readdata_valid			(slave_if_readdata_valid),	// slave readvalid    (s)
	.slave_if_waitrequest				(slave_if_waitrequest) 		// slave readvalid    (s)
);

 // +-------------------------------------------------------------------
 // +
avalon_st_traffic_controller TRAFFIC_CTRL (
        .clk							(xgmii_clk),           
        .reset_n						(reset_n),
		//.gen_mon_lpbk   				(1'b0),
		.avl_mm_read      				(slave_if_read[1]),
		.avl_mm_write     				(slave_if_write[1]),
		.avl_mm_waitrequest 			(slave_if_waitrequest[1]),
		.avl_mm_baddress   				(slave_if_address[23:0]),	// byte address
		.avl_mm_readdata  				(slave_if_readdata[63:32]),
		.avl_mm_writedata 				(slave_if_writedata[63:32]),
        .avl_st_rx_data					(avalon_st_rx_data),
        .avl_st_rx_empty				(avalon_st_rx_empty),
        .avl_st_rx_eop					(avalon_st_rx_endofpacket),
        .avl_st_rx_error				(avalon_st_rx_error),
        .avl_st_rx_ready				(avalon_st_rx_ready),
        .avl_st_rx_sop					(avalon_st_rx_startofpacket),
        .avl_st_rx_val					(avalon_st_rx_valid),

        .mac_rx_status_valid			(),
        //.mac_rx_status_error			(rx_status_error),
        .mac_rx_status_error			(),
        .mac_rx_status_data				(),

        .stop_mon						(STOPMON),
        .mon_active						(mon_active),
        .mon_done						(mon_done),
        .mon_error						(mon_error),

        .avl_st_tx_data					(avalon_st_tx_data),
        .avl_st_tx_empty				(avalon_st_tx_empty),
        .avl_st_tx_eop					(avalon_st_tx_endofpacket),
        .avl_st_tx_error				(avalon_st_tx_error),
        .avl_st_tx_ready				(avalon_st_tx_ready),
        .avl_st_tx_sop					(avalon_st_tx_startofpacket),
        .avl_st_tx_val					(avalon_st_tx_valid)
);
        	  
		  
		  
		  
		  
		  
		  
        sv_rc_bundle reconfig_bundle2 (
        .reconfig_clk                                           (mm_clk),
        .reconfig_reset                                         (reset),
        .reconfig_from_xcvr                                     (ch2_reconfig_from_xcvr),
        .reconfig_to_xcvr                                       (ch2_reconfig_to_xcvr),
        .reconfig_mgmt_busy                                     (reconfig_mgmt_busy2),
        // .seq_pcs_mode                                           ({2'b0,ch2_mode_1g_10gbar,~ch2_mode_1g_10gbar,2'b0}),
        .seq_pcs_mode                                           (ch2_seq_pcs_mode),
        .seq_pma_vod                                            (ch2_seq_pma_vod),
        .seq_pma_postap1                                        (ch2_seq_pma_postap1),
        .seq_pma_pretap                                         (ch2_seq_pma_pretap),
        .seq_start_rc                                           (ch2_seq_start_rc),
        .lt_start_rc                                            (ch2_lt_start_rc),
        .tap_to_upd                                             (ch2_tap_to_upd),
        .hdsk_rc_busy                                           (ch2_hdsk_rc_busy), // reconfig is busy
        .baser_ll_mif_done                                      (ch2_baser_ll_mif_done),
        .rx_sync_lock                                           (ch2_rx_sync_lock),




        );
        defparam reconfig_bundle2.PMA_RD_AFTER_WRITE = 0;
        defparam reconfig_bundle2.CHANNELS = 1;
        defparam reconfig_bundle2.PLLS = 2;              // 2 for signale channel 4 for 2 channel
        defparam reconfig_bundle2.SYNTH_1588_1G = 0;
        defparam reconfig_bundle2.SYNTH_1588_10G = 0;
        defparam reconfig_bundle2.KR_PHY_SYNTH_AN = 0;   // should enable it later
        defparam reconfig_bundle2.KR_PHY_SYNTH_LT = 0;   // should enable it later
        defparam reconfig_bundle2.KR_PHY_SYNTH_GIGE = 1;
        
        
     
        
        
        
    


endmodule         
        