# (C) 2001-2012 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Altera Program License Subscription 
# Agreement, Altera MegaCore Function License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Altera and sold by 
# Altera or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


global env ;

#==============================================================================
# Create project top and ip folder                
#==============================================================================
if {![project_exists altera_eth_10g_mac_base_kr_top]} {
    project_new altera_eth_10g_mac_base_kr_top
    post_message -type info "Created new project: altera_eth_10g_mac_base_kr_top\n"
}
 
#==============================================================================
# Set project environment              
#==============================================================================
set_global_assignment -name FAMILY "Stratix V"
set_global_assignment -name DEVICE 5SGXEA7N2F40C2
set_global_assignment -name TOP_LEVEL_ENTITY altera_eth_10g_mac_base_kr_top
set_global_assignment -name QIP_FILE reconfig/reconfig.qip
set_global_assignment -name QIP_FILE altera_eth_10g_mac_base_kr/synthesis/altera_eth_10g_mac_base_kr.qip
set_global_assignment -name VERILOG_FILE altera_eth_10g_mac_base_kr_top.v
set_global_assignment -name VERILOG_FILE altera_eth_addr_swapper.v
set_global_assignment -name SDC_FILE altera_eth_10g_mac_base_kr_top.sdc
set_global_assignment -name FITTER_EFFORT "STANDARD FIT"
set_global_assignment -name OPTIMIZE_HOLD_TIMING "ALL PATHS"
set_global_assignment -name OPTIMIZE_MULTI_CORNER_TIMING ON

file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/rom_10g_1588.v ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/rom_10g_baser.v ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/rom_10g_ll.v ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/rom_10g.v ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/rom_1g_1588.v ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/rom_1g.v ./

set_global_assignment -name SYSTEMVERILOG_FILE $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/mgmt_memory_map.sv -library "reconfig"
set_global_assignment -name SYSTEMVERILOG_FILE $env(QUARTUS_ROOTDIR)/../ip/altera/alt_xcvr/utils/mgmt_master/mgmt_commands_h.sv -library "reconfig"
set_global_assignment -name SYSTEMVERILOG_FILE $env(QUARTUS_ROOTDIR)/../ip/altera/alt_xcvr/utils/mgmt_master/mgmt_cpu.sv -library "reconfig"
set_global_assignment -name SYSTEMVERILOG_FILE $env(QUARTUS_ROOTDIR)/../ip/altera/alt_xcvr/utils/mgmt_master/mgmt_functions_h.sv -library "reconfig"
set_global_assignment -name SYSTEMVERILOG_FILE $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/mgmt_program_1g10g_mif.sv -library "reconfig"
set_global_assignment -name SYSTEMVERILOG_FILE $env(QUARTUS_ROOTDIR)/../ip/altera/alt_xcvr/utils/mgmt_master/mgmt_master.sv -library "reconfig"
set_global_assignment -name SYSTEMVERILOG_FILE $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/sv_rc_bundle.sv -library "reconfig"
set_global_assignment -name VERILOG_FILE rom_10g_1588.v
set_global_assignment -name VERILOG_FILE rom_10g_baser.v
set_global_assignment -name VERILOG_FILE rom_10g_ll.v
set_global_assignment -name VERILOG_FILE rom_10g.v
set_global_assignment -name VERILOG_FILE rom_1g_1588.v
set_global_assignment -name VERILOG_FILE rom_1g.v
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/baser_channel.mif ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/ll_channel.mif ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/mif_10g_1588_inst_channel.mif ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/mif_10g_inst_channel.mif ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/mif_1g_1588_inst_channel.mif ./
file copy -force $env(QUARTUS_ROOTDIR)/../ip/altera/ethernet/altera_eth_10g_design_example/design_example_components/base_kr/mif_1g_inst_channel.mif ./



# analog setting need to be set 
set_instance_assignment -name XCVR_TX_VOD 35 -to ch0_tx_serial_data
set_instance_assignment -name XCVR_TX_PRE_EMP_1ST_POST_TAP 14 -to ch0_tx_serial_data
set_instance_assignment -name XCVR_TX_PRE_EMP_PRE_TAP 3 -to ch0_tx_serial_data

set_instance_assignment -name XCVR_TX_VOD 35 -to ch1_tx_serial_data
set_instance_assignment -name XCVR_TX_PRE_EMP_1ST_POST_TAP 14 -to ch1_tx_serial_data
set_instance_assignment -name XCVR_TX_PRE_EMP_PRE_TAP 3 -to ch1_tx_serial_data

# if 10G Base KR is set to turn ON Link Training
set_instance_assignment -name XCVR_RX_LINEAR_EQUALIZER_CONTROL 8 -to ch0_rx_serial_data
set_instance_assignment -name XCVR_RX_EQ_BW_SEL BW_FULL_12P5 -to ch0_rx_serial_data

set_instance_assignment -name XCVR_RX_LINEAR_EQUALIZER_CONTROL 8 -to ch1_rx_serial_data
set_instance_assignment -name XCVR_RX_EQ_BW_SEL BW_FULL_12P5 -to ch1_rx_serial_data



export_assignments
